/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 *  Copyright (C) 2010      by GJ Designing Center Print Business Group
 *                             RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 */

/*
 *  ץå¸⥸塼AT91SAM7Sѡ
 */


#ifndef	_CPU_CONFIG_H_
#define	_CPU_CONFIG_H_

#define MAX_IPM  0xf	/* ֤ʤξϺǹͥ٤CPUå */


#ifndef _MACRO_ONLY
#include "cpu_insn.h"
#endif /* _MACRO_ONLY */

#ifndef _MACRO_ONLY
/* 饤ؿץȥ	*/
Inline void set_ipl(UINT8 ipl);
Inline UINT8 current_ipl(void);


/*
 *  OSͥǤϳIե饰ڤIPLѤƹԤ
 *  ȤȤ롥CPUIPLΤߤʤᡢ
 *  Iե饰򥽥եȥ䤦ͤȤ
 */

/*
 *  ͥ٥٥
 */
Inline void set_ipl(UINT8 ipl)
{
}


/*
 *  ͥ٥٥
 */
Inline UINT8 current_ipl(void)
{
	return 0;
}

/*
 *  ץå¸ν(cpu_config.c)
 */
extern void	cpu_initialize(void);

/*
 *  ץå¸νλ(cpu_config.c)
 */
extern void	cpu_terminate(void);

#define DEFINE_CTXB(tnum) \
FP tcxb_pc[tnum]; \
VP tcxb_sp[tnum];

extern FP tcxb_pc[];
extern VP tcxb_sp[];

/* ǥѥåΥ֥ؿץȥ	*/
extern void  dispatch(void);
extern void  exit_and_dispatch(void);
extern void  start_dispatch(void);

/*
 *  ߥϥɥνޥ
 *
 *  NC30WAǤFB/SBʳϥå쥸Ǥ뤿
 *  Ԥ. 
 */
/*
 *  ISR1ޥ
 *
 *  ISR1Ƥν桼Ҥϡcpu_defs.h ˤ̵ޥ
 *  OMIT_ISR1_ENTRYפͭˤ뤳ȡ
 */
/* ٥ơ֥뤫γޥ	*/
/*
 *  ֤ȥ٥ơ֥̥եɬפȤʤ롥
 *  M16CƤΥƥǡƱեϤȤʤäƤ뤿ܥޥ
 *  Ѥ줿ʤǽ⤢롥
 *  ̥եϤԤθܤϻĤƤ
 */
#define	ISR1_EXTERNAL(isr)		asm("	.extern	_" #isr "_entry")

/* ٥ơ֥Ͽܥޥ	*/
#define	ISR1_SYMBOL(isr)		asm("	.long	_" #isr "_entry")

/* ޥ	*/
#define ISR1_ENTRY(isr)\
asm(".text					\n"\
"	.align 2				\n"\
"   .arm                    \n"\
"	.global _" #isr "_entry \n"\
"_" #isr "_entry:			\n"\
"   msr   cpsr_fc, #0xdf      \n"\
"   stmfd sp!, {r0-r3, r8-r11,  ip, lr}\n"\
"   msr   cpsr_fc, #0xd2    \n"	/* switch to the irq stack to get  spsr (in r0) and lr (in r1) */\
"   sub   r1, lr, #4        \n"	/* fix up the link register value for return */\
"   mrs   r0, spsr          \n"\
"   msr   cpsr_fc, #0xdf    \n"	/* switch back to the system stack and save spsr  and lr there */\
"   stmfd sp!, {r0-r1}      \n"\
	/* Acknowledge the IVR for debugging to support Protected Mode */\
	/* just following the leJos convention */\
"   ldr	  r0, =0xFFFFF100   \n"\
"   str	  r0, [r0]          \n"\
	/* save the C_function address in r11 */\
"   ldr	r11, =" #isr "      \n"\
"   mov	lr, pc              \n"\
"   bx	r11                 \n"	/* call C function */\
"   b   int_return");

/*
 *  ISR2ޥ
 */
/* ٥ơ֥뤫γޥ	*/
/*
 *  ֤ȥ٥ơ֥̥եɬפȤʤ롥
 *  M16CƤΥƥǡƱեϤȤʤäƤ뤿ܥޥ
 *  Ѥ줿ʤǽ⤢롥
 *  ̥եϤԤθܤϻĤƤ
 */
#define	ISR2_EXTERNAL(isr)		asm("	.global	_" #isr "_entry")

/* ٥ơ֥Ͽܥޥ	*/
#define	ISR2_SYMBOL(isr)		asm("	.long	_" #isr "_entry")

/* ޥ	*/
#define ISR2_ENTRY(isr, isrid)\
asm(".text					\n"\
"	.align 2				\n"\
"   .arm                    \n"\
"	.global _" #isr "_entry \n"\
"_" #isr "_entry:			\n"\
"   msr   cpsr_fc, #0xdf      \n"\
"   stmfd sp!, {r0-r3, r8-r11,  ip, lr}\n"\
"   msr   cpsr_fc, #0xd2    \n"	/* switch to the irq stack to get  spsr (in r0) and lr (in r1) */\
"   sub   r1, lr, #4        \n"	/* fix up the link register value for return */\
"   mrs   r0, spsr          \n"\
"   msr   cpsr_fc, #0xdf    \n"	/* switch back to the system stack and save spsr  and lr there */\
"   stmfd sp!, {r0-r1}      \n"\
	/* Acknowledge the IVR for debugging to support Protected Mode */\
	/* just following the leJos convention */\
"   ldr	  r0, =0xFFFFF100   \n"\
"   str	  r0, [r0]          \n"\
	/* save runisr in R8 and update it with the current isr value */\
"   ldr	  r0, =runisr       \n"\
"   ldrb  r8, [r0]          \n"	/* save runisr in R8 */\
"   mov	  r1, #" #isrid "   \n"\
"   strb  r1, [r0]          \n"\
	/* save the C_function address in r11 */\
"   ldr	r11, =ISRMain" #isr "\n"\
"   b	_interrupt");


/* ٥ơ֥Ͽܥޥ	*/
#define	UNUSED_INT_SYMBOL()		asm("	.long	0")

#endif /* _MACRO_ONLY */
#endif	/* _CPU_CONFIG_H_	*/

